﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace TestAppointmentsComponentOne.Converters
{
    public class BoolToWrappingConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null) return TextWrapping.NoWrap;

            return (bool)value ? TextWrapping.Wrap : TextWrapping.NoWrap;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class BoolToTrimmingConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null) return TextTrimming.WordEllipsis;

            return (bool)value ? TextTrimming.None : TextTrimming.WordEllipsis;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class NotesTextConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            
            if (values[0] == null || values[0] == DependencyProperty.UnsetValue )//|| values[1] == DependencyProperty.UnsetValue)
                return null;

            //if ((bool)values[1])
            //    return values[0];

            var str = values[0].ToString();
            if (!str.Contains("\n"))
                return str;

            var pos = str.IndexOf("\r\n", StringComparison.Ordinal);
            if (pos == -1)
            {
                pos = str.IndexOf("\n", StringComparison.Ordinal);
            }
            return str.Substring(0, pos) + "…";
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class ToolTipConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            return values[0] == DependencyProperty.UnsetValue || values[1] == DependencyProperty.UnsetValue || (bool)values[1] || values[0] == null ? null : values[0];
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
